"use strict";

const marked = require("marked");
var hljs = require("highlight.js");

var renderer = new marked.Renderer();

renderer.heading = function (text, level) {
  var escapedText = text.toLowerCase().replace(/[^\w]+/g, '-');

  return '<h' + level + '><a name="' +
    escapedText +
    '" class="anchor" href="#' +
    escapedText +
    '"><span class="header-link"></span></a>' +
    text + '</h' + level + '>';
};

var config = Object.assign({}, hexo.config.mark);

if (config.highlight) {
  marked.setOptions({
    highlight: function (code, lang) {
      var res;
      if (lang) {
        res = hljs.highlight(lang, code, true).value;
      } else {
        res = hljs.highlightAuto(code).value;
      }
      return res;
    }
  });
}

function _renderer(data, options) {
  return marked(data.text, { renderer: renderer });
}

hexo.extend.renderer.register('md', 'html', _renderer, true);
hexo.extend.renderer.register('markdown', 'html', _renderer, true);
hexo.extend.renderer.register('mkd', 'html', _renderer, true);
hexo.extend.renderer.register('mkdn', 'html', _renderer, true);
hexo.extend.renderer.register('mdwn', 'html', _renderer, true);
hexo.extend.renderer.register('mdtxt', 'html', _renderer, true);
hexo.extend.renderer.register('mdtext', 'html', _renderer, true);
